## unzip-crypt 5.50

=== debian/changelog ===
unzip-crypt (5.50) unstable; urgency=low

  * Dummy package so that unzip replaces the old unzip-crypt.

 -- Santiago Vila <sanvila@debian.org>  Sun, 31 Mar 2002 13:49:34 +0200
