## unzip-crypt 5.50.3

=== debian/changelog ===
unzip-crypt (5.50.3) unstable; urgency=low

  * Removed doc symlinks.

 -- Santiago Vila <sanvila@debian.org>  Sun, 24 Aug 2003 14:00:30 +0200
