=== debian/control ===
Source: unzip-crypt
Section: oldlibs
Priority: extra
Maintainer: Santiago Vila <sanvila@debian.org>
Standards-Version: 3.6.0

Package: unzip-crypt
Architecture: all
Depends: unzip
Description: Legacy package for unzip-crypt that you should remove
 This package exists only to provide a smooth upgrade from the old unzip-crypt
 to the new unzip. Please remove it.
